# User's demos

## WHILL MODEL CR with move to a pose control

This is an electric wheelchair control demo by [Katsushun89](https://github.com/Katsushun89).

[WHILL Model CR](https://whill.jp/model-cr) is the control target, [M5Stack](https://m5stack.com/) is used for the controller, and [toio](https://toio.io/) is used for the control input device.

[move-to-a-pose-control](https://pythonrobotics.readthedocs.io/en/latest/modules/path_tracking.html#move-to-a-pose-control) is used for its control algorithm ([code link](https://github.com/AtsushiSakai/PythonRobotics/blob/master/PathTracking/move_to_pose/move_to_pose.py)).

![1](https://github.com/AtsushiSakai/PythonRoboticsGifs/blob/master/Users/WHILL_Model_CR_with_move_to_a_pose/WHLL_Model_CR_with_move_to_a_pose.gif)

Ref:

- [toioと同じように動くWHILL Model CR (in Japanese)](https://qiita.com/KatsuShun89/items/68fde7544ecfe36096d2)


# Educational users

This is a list of users who are using PythonRobotics for education.

If you found other users, please make an issue to let me know.

- [CSCI/ARTI 4530/6530: Introduction to Robotics (Fall 2018),  University of Georgia ](http://cobweb.cs.uga.edu/~ramviyas/csci_x530.html)

# Stargazers location map

You can check stargazer's locations of this project from:

- [Stargazers location map](https://drive.google.com/open?id=1bBXS9IQmZ3Tfe1wNGvJbObRt9Htt4PGC&usp=sharing)


# Related projects

This is a list of related projects. 

- [onlytailei/CppRobotics: cpp implementation of robotics algorithms including localization, mapping, SLAM, path planning and control](https://github.com/onlytailei/CppRobotics)

# Individual users comments

These are comments from user's using [![Say Thanks!](https://img.shields.io/badge/Say%20Thanks-!-1EAEDB.svg)](https://saythanks.io/to/AtsushiSakai)

---

Dear AtsushiSakai, <br>thank you for building this cool repo for robotics. <br>I am still learning robotics and this will give me a good starting point. <br>I hope this note gets to you. <br> <br>

--David Senicic

---

Dear AtsushiSakai, <br>WE found your project from google when first searching for a rosbag to csv converter. We are a small team in MCity working on Connected (and Automated) vehicles. We are working with an opensource platform that serve as the AI to control the vehicle. Your code and documentation helped us a lot! <br> <br>Thank you! Have a nice day!

--Hanlin(Julia) Chen, MCity Apollo team

---

Dear Atsushi Sakai, <br> <br>With your simplistic descriptions in text and as gifs, i was able to help my students understand easily and effectively, I would be honored to help, in anyway towards this, As a hobbyist have been developing lidar based slam navigation systems from 2011 and its only right to acknowledge and thank you for your contributions.

--Shiva

---

Dear Atsushi Sakai <br>I first came across your Matlab repository on ICP and SLAM. The repository for both python and Matlab helped me in understanding the essential concepts of robotics.I am really grateful to you for helping me develop my understanding of the concepts of robotics.

--Sparsh Garg

---

Dear AtsushiSakai, <br>Thank you very much for all the example programs related to Robotics

--Kalyan

---
Dear AtsushiSakai, <br> <br>Thanks for Python Robotics

--Rebecca Li

---

Thanks alot.

--Zain

--- 

Dear AtsushiSakai,<br> <br>thank you for you code!

—- Anonymous

--- 

Thanks!

--a friend

--- 

Thanks for the awesome collection of codes!

--Qi

---

Thank you!

--huang pingzhong

---

Dear AtsushiSakai, <br>Thanks a lot for the wonderful collection of projects.It was really useful. I really appreciate your time in maintaing and building this repository.It will be really great if I get a chance to meet you in person sometime.I got really inspired looking at your work. <br>All the very best for all your future endeavors! <br> Thanks once again, <br>

---Ezhil Bharathi 

---

Dear Atsushi Sakai, <br>Thank you so much for gathering all the useful stuff and good examples of robotics things ! :) <br>I am very new in this area and want to know more about robotics and SLAM things.  <br>and again, thank you so much :) <br>

--Tutorgaming

---

Dear AtsushiSakai, <br>Very excellent work. Thank you for your share.

--Thomas Yang

---

Dear Atsushi Saka Arigato 🤗🤗

--Badal Kumar

---

Dear AtsushiSakai, <br>Thanks for teaching how to implement path planning algorithms in robotics. <br>

---

Your Github page is very useful. I will apply it with cooperative robot.

--Soloist

---

help me very much thankyou

--sanchuan

---

Dear AtsushiSakai, <br>U R so niubility!

--FangKD

---

thankyou AtsushiSakai!

--ou minghua

---

Dear AtsushiSakai <br>Thank You

--Dogukan Altay

---

so kind of you can you make videos of it.

---

Dear AtshshiSakai, <br>You are very wise and smart that you created this library for students wanting to learn Probabilistic Robotics and actually perform robot control. <br>Hats off to you and your work. <br>I am also reading your book titled : Python Robotics

--Himanshu

---

Dear AtsushiSakai, <br>Hello! YOUR CODE IS SUPER SUPER HELPFUL AND GIVES ME CLEAR INSTRUCTIONs as well as STRONG SUPPORT!! <br>Thank you so much !

--Lee

---

Hi AtsushiSakai, <br> <br>Thanks for creating the pythonrobotics repo! It's an awesome repo that has been of great help to me. I've referenced your extended kalman filter algorithm while creating my own for localization using a 2D lidar, camera, and IMU. Our robot is destined to compete soon, so fingers crossed that all works out! Thanks again.

---

You rock!

--Matt

---

Dear AtsushiSakai, <br>You are the best. This is by far the best tutorial for learning and implementing robotics. <br>Thanks a lot for your time and efforts to do this!

--Adi B

---

Dear Atushi, thank you for this amazing repository. It is a pleasure to have access to python algorithms without the burden of ROS. While I'm no longer working on such robotics projects, it's wonderful to know its available when I need it and it was amazing to see all the beautiful animations for each algorithm.

--Shreeyak Sajjan

---

Dear AtsushiSakai <br>Thank you for your contributions!

--Luo

---

Dear AtsushiSakai, Your visualizations are awesome, and I am going to have this link bookmarked for future references. Thank you!

--Srinivasa Varadhan Agaram Chakravarthy

---

Dear AtsushiSakai, <br>Thank you for this great resource! I very much appreciate all your hard work and effort.

--Mridul Aanjaneya

---

Thank you for the python robotics sample code and visualizations!! This is my new favorite thing on the internet.

--selamg@mit.edu

---

Mr AtsushiSakai .. <br>Your work and teaching is light for me <br>thank you very much for giving time and effort to make it public for us

--Karim Anass

---

Thank You

--Anonymous

---

I've learned the robotics from the traditional way of solving problem through finding packages and reading papers. This amazing project is unbelievably helpful for new-comers to learn and get familiar with the algorithms. Gods know how many hours you've taken to sort all the materials and written everything into one single coherent project. I'm truly amazed and deepest appreciation.

--Ewing Kang

---

Hey, I'm a student and I just recently got into robotics, and visited your repository multiple times. Today I was super happy to find the link to Patreon! I am impressed by didactic quality of the repo, keep up the good work!

--Carolina Bianchi

---

Dear AtsushiSakai, thanks a lot for the PythonRobotics git repository. I'm a college student who is trying to make a mini autonomous robot for my final project submission, I still haven't started using your code but by the look of it I'm sure it will be of greater use. Will let you know how my project is coming up.

--Pragdheesh

---

Hello AtsushiSakai, <br> <br>Thank you very much for sharing your work!

--Uma K

---

Hey Atsushi <br>We are working on a multiagent simulation game and this project gave us really good insights. <br>In future, I would like to contribute to this project with our multiagent task allocation among robots and multi robot map merging( Which is a big hurdle as we found). <br>Thanks for what you are doing for open source. <br>

--Mayank

---

Thanks a lot for this amazing set of very useful librarires!

--Razvan Viorel Mihai

---

Dear Atsushi Sakai, <br> <br>This is probably one of the best open-source robotics based Algorithms I have seen so far. Thank you for posting this knowledge with other engineers. It will definitely help soon to become engineers like myself.

--Don

---

hanks frnd, for ur contibusion

—--

Thank you for python robotics!!

--Manuel Miguez

---

Great job

--Anonymous

---

Dear Atsushi Sakai <br>Thank you for the Python Robotics

--Alex Liberzon

---

Thanks for your robotics repo!

--Mithi

---

You made such a nice work. Congratulations :)

--ATroya

---

thank you for python path finding repo

--fengzongbao

---

Dear AtsushiSakai, <br> <br>Thank you so much for making the concept of robotics approachable for the general mass. Keep up the good work :)

--Harsh Munshi

---

Benefit a lot for your GitHub repository of PythonRobotics. Thanks so much.

--Haoran

---

Thanks!

--Reinzor

---

Thanks for writing these algorithms. They are very helpful for learning robotics.

--Arihant Lunawat

---

Dear AtsushiSakai, <br>Thank you for providing us this great repository for playing and look around:)!

--Hsin-Wen

---

Thanks for PythonRobotics!

--Nick V

---

Dear AtsushiSakai, thank you so much for this material, it's so useful to me, i'm really glad with it =D

--Juanda

---

Dear Atsushi Thanks for compiling such a vast resource for robotics motion planning.

--Kartik Prakash

---

Thanks for your job! <br>I have learned a lot from it!

--ZhongyiShen

---

Dear Atsushi Sakai, <br>Thank you so much for creating PythonRobotics and documenting it so well. I am a senior in high school trying to learn and better myself in these concepts.

--Rohan Mathur



# Citations

1. B. Blaga, M. Deac, R. W. Y. Al-doori, M. Negru and R. Dǎnescu, "Miniature Autonomous Vehicle Development on Raspberry Pi," 2018 IEEE 14th International Conference on Intelligent Computer Communication and Processing (ICCP), Cluj-Napoca, Romania, 2018, pp. 229-236.
doi: 10.1109/ICCP.2018.8516589
keywords: {Automobiles;Task analysis;Autonomous vehicles;Path planning;Global Positioning System;Cameras;miniature autonomous vehicle;path planning;navigation;parking assist;lane detection and tracking;traffic sign recognition},
URL: http://ieeexplore.ieee.org/stamp/stamp.jsp?tp=&arnumber=8516589&isnumber=8516425

2. Peggy (Yuchun) Wang and Caitlin Hogan, "Path Planning with Dynamic Obstacle Avoidance for a Jumping-Enabled Robot", AA228/CS238 class report, Department of Computer Science, Stanford University, URL: https://web.stanford.edu/class/aa228/reports/2018/final113.pdf

3. Welburn, E, Hakim Khalili, H, Gupta, A, Watson, S & Carrasco, J 2019, A Navigational System for Quadcopter Remote Inspection of Offshore Substations. in The Fifteenth International Conference on Autonomic and Autonomous Systems 2019. URL:https://www.research.manchester.ac.uk/portal/files/107169964/ICAS19_A_Navigational_System_for_Quadcopter_Remote_Inspection_of_Offshore_Substations.pdf

4. E. Horváth, C. Hajdu, C. Radu and Á. Ballagi, "Range Sensor-based Occupancy Grid Mapping with Signatures," 2019 20th International Carpathian Control Conference (ICCC), Krakow-Wieliczka, Poland, 2019, pp. 1-5.
URL: http://ieeexplore.ieee.org/stamp/stamp.jsp?tp=&arnumber=8765684&isnumber=8765679

5. Josie Hughes, Masaru Shimizu, and Arnoud Visser, "A Review of Robot Rescue Simulation Platforms for Robotics Education"
URL: https://2019.robocup.org/downloads/program/HughesEtAl2019.pdf

6. Hughes, Josie, Masaru Shimizu, and Arnoud Visser. "A review of robot rescue simulation platforms for robotics education." (2019).
URL: https://www.semanticscholar.org/paper/A-Review-of-Robot-Rescue-Simulation-Platforms-for-Hughes-Shimizu/318a4bcb97a44661422ae1430d950efc408097da

7. Ghosh, Ritwika, et al. "CyPhyHouse: A Programming, Simulation, and Deployment Toolchain for Heterogeneous Distributed Coordination." arXiv preprint arXiv:1910.01557 (2019).
URL: https://arxiv.org/abs/1910.01557

8. Hahn, Carsten, et al. "Dynamic Path Planning with Stable Growing Neural Gas." (2019).
URL: https://pdfs.semanticscholar.org/5c06/f3cb9542a51e1bf1a32523c1bc7fea6cecc5.pdf

# Others

- Autonomous Vehicle Readings https://richardkelley.io/readings

- 36 Amazing Python Open Source Projects (v.2019) – Mybridge for Professionals https://medium.mybridge.co/36-amazing-python-open-source-projects-v-2019-2fe058d79450

- Real-time Model Predictive Control (MPC), ACADO, Python | Work-is-Playing http://grauonline.de/wordpress/?page_id=3244

